/* Definitions of target machine for GNU compiler.  Vxworks Aarch 64bit
   version.
   Copyright (C) 2017 Free Software Foundation, Inc.
   Contributed by Douglas B Rupp

This file is part of GCC.

GCC is free software; you can redistribute it and/or modify it under
the terms of the GNU General Public License as published by the Free
Software Foundation; either version 3, or (at your option) any later
version.

GCC is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with GCC; see the file COPYING3.  If not see
<http://www.gnu.org/licenses/>.  */

#undef DEFAULT_ABI
#define DEFAULT_ABI ABI_ELFv2

#undef CPP_SPEC
#define CPP_SPEC VXWORKS_ADDITIONAL_CPP_SPEC

/* Windriver's VSB targeting aarch64 only support being used by their llvm
   compiler. We thus declare ourselves as a llvm toolchain
   (see config/vxworks.h) by setting _VX_TOOL_FAMILY and _VX_TOOL to
   llvm.  */
#undef TARGET_VXWORKS_VXWA_LLVM
#define TARGET_VXWORKS_VXWA_LLVM 1

/* The VxWorks kernel uses R18 as the TCB pointer.  */
#undef FIXED_R18
#define FIXED_R18 1

#undef TARGET_OS_CPP_BUILTINS
#define TARGET_OS_CPP_BUILTINS()	  \
  do {					  \
    builtin_define ("ARMEL");		  \
    builtin_define ("_VX_CPU=ARMARCH8A"); \
    VXWORKS_OS_CPP_BUILTINS ();		  \
  } while (0)

#undef VXWORKS_LIBS_RTP
#define VXWORKS_LIBS_RTP "-lc -lgcc -lc_internal -lnet"

#undef VXWORKS_HAVE_TLS
#define VXWORKS_HAVE_TLS 1

#undef SUBTARGET_OVERRIDE_OPTIONS
#define SUBTARGET_OVERRIDE_OPTIONS VXWORKS_OVERRIDE_OPTIONS

/* fno-reorder-functions prevents the generation of .text.hot and 
   .text.unlikely sections, as they are badly handled by vxworks loader for
   the exception unwinding in kernel mode.
   The arm-style exception unwinding requires only one .text section, which is
   normally the case for fully linked elf objects, but as vxw kernel objects
   are just partially linked, having several text sections makes all .text.*
   sections invisible to unwinding. */
#undef  CC1_SPEC
#define CC1_SPEC "%{!mrtp:-fno-reorder-functions -ftls-model=local-exec}"

#undef LINK_SPEC
#define LINK_SPEC VXWORKS_LINK_SPEC

#undef LIB_SPEC
#define LIB_SPEC VXWORKS_LIB_SPEC

#undef STARTFILE_SPEC
#define STARTFILE_SPEC VXWORKS_STARTFILE_SPEC

#undef ENDFILE_SPEC
#define ENDFILE_SPEC VXWORKS_ENDFILE_SPEC

/* There is no default multilib.  */
#undef MULTILIB_DEFAULTS

#define FPUTYPE_DEFAULT "vfp"

#undef FUNCTION_PROFILER
#define FUNCTION_PROFILER VXWORKS_FUNCTION_PROFILER

#undef PTRDIFF_TYPE
#define PTRDIFF_TYPE ("long int")

#undef  WCHAR_TYPE
#define WCHAR_TYPE ("int")
#undef  WCHAR_TYPE_SIZE
#define WCHAR_TYPE_SIZE 32

#undef ASM_OUTPUT_BEFORE_CASE_LABEL
#define ASM_OUTPUT_BEFORE_CASE_LABEL(FILE, PREFIX, NUM, TABLE) \
  ASM_OUTPUT_ALIGN ((FILE), 3);

/* Define this to be nonzero if static stack checking is supported.  */
#define STACK_CHECK_STATIC_BUILTIN 1

#undef STACK_CHECK_PROTECT
#define STACK_CHECK_PROTECT 16384
