/* Target independent definitions for LynxOS-178Elf.
   Copyright (C) 2014,2016,2018 Free Software Foundation, Inc.

This file is part of GCC.

GCC is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 3, or (at your option)
any later version.

GCC is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with GCC; see the file COPYING3.  If not see
<http://www.gnu.org/licenses/>.  */

#undef TARGET_LYNXOS
#define TARGET_LYNXOS 178

#ifndef CPP_OS_LYNX_SPEC
# define CPP_OS_LYNX_SPEC \
"%{mthreads: -D_MULTITHREADED} \
 -Asystem=lynx -Asystem=unix -D__Lynx__ -D__unix__ \
 %{!nostdinc: %{isystem*} -idirafter %:getenv(ENV_PREFIX /usr/include)}"
#endif

#ifndef LIB_OS_LYNX_SPEC
# define LIB_OS_LYNX_SPEC "-lm -lc"
#endif

#ifndef LINK_OS_LYNX_SPEC
# define LINK_OS_LYNX_SPEC \
"%{L*} \
 %{mthreads: -L %:getenv(ENV_PREFIX /lib/thread)} \
 %{!mthreads: -L %:getenv(ENV_PREFIX /lib)}"
#endif

#ifndef STARTFILE_OS_LYNX_SPEC
# define STARTFILE_OS_LYNX_SPEC \
"%{mthreads: \
 %{p:%:getenv(ENV_PREFIX /lib/thread/gcrt1.o%s)} \
 %{pg:%:getenv(ENV_PREFIX /lib/thread/gcrt1.o%s)} \
 %{!p:%{!pg:%:getenv(ENV_PREFIX /lib/thread/crt1.o%s)}} \
 %:getenv(ENV_PREFIX /lib/thread/crti.o%s)} \
 %{!mthreads: \
 %{p:%:getenv(ENV_PREFIX /lib/gcrt1.o%s)} \
 %{pg:%:getenv(ENV_PREFIX /lib/gcrt1.o%s)} \
 %{!p:%{!pg:%:getenv(ENV_PREFIX /lib/crt1.o%s)}} \
 %:getenv(ENV_PREFIX /lib/crti.o%s)} \
 crtbegin.o%s"
#endif

#ifndef ENDFILE_OS_LYNX_SPEC
# define ENDFILE_OS_LYNX_SPEC \
"crtend.o%s \
 %{mthreads: \
 %:getenv(ENV_PREFIX /lib/thread/crtn.o%s)} \
 %{!mthreads: \
 %:getenv(ENV_PREFIX /lib/crtn.o%s)}"
#endif

#ifndef PREFERRED_DEBUGGING_TYPE
# define PREFERRED_DEBUGGING_TYPE DWARF2_DEBUG
#endif

#ifndef TARGET_HAS_F_SETLKW
# define TARGET_HAS_F_SETLKW
#endif

#ifndef TARGET_POSIX_IO
# define TARGET_POSIX_IO
/* LynxOS-178 fcntl.h defines F_RDLCK and flock only if OPEN_GROUP is defined */
# define OPEN_GROUP
#endif

/* LynxOS uses the -mthreads option to enable thread support.  */
#undef GOMP_SELF_SPECS
#define GOMP_SELF_SPECS "%{fopenmp|ftree-parallelize-loops=*: -mthreads}"
