/* Definitions for PPC running LynxOS-178E.
   Copyright (C) 2014,2016,2018 Free Software Foundation, Inc.

   This file is part of GCC.

   GCC is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published
   by the Free Software Foundation; either version 3, or (at your
   option) any later version.

   GCC is distributed in the hope that it will be useful, but WITHOUT
   ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
   or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
   License for more details.

   You should have received a copy of the GNU General Public License
   along with GCC; see the file COPYING3.  If not see
   <http://www.gnu.org/licenses/>.  */

#undef CC1_SPEC
#define CC1_SPEC \
"%{G*} %{mno-sdata:-msdata=none} \
 -maix-struct-return"

/* Override the definition from lynx.h.  */

#undef TARGET_OS_CPP_BUILTINS
#define TARGET_OS_CPP_BUILTINS()		\
  do						\
    {						\
      builtin_define ("__BIG_ENDIAN__");	\
      builtin_define ("__powerpc__");		\
      builtin_assert ("cpu=powerpc");		\
      builtin_assert ("machine=powerpc");	\
      builtin_define ("__PPC__");		\
      if (TARGET_ALTIVEC_ABI)			\
        builtin_define ("__ALTIVEC_ABI__");	\
    }						\
  while (0)

#ifdef CRTSTUFFS_O
#define LYNX_CHECK_TOC \
	asm ("stwu 1,-16(1); stw 30,8(1);" \
	     "bl 1f;.long .LCTOC1-.;1: mflr 30; lwz 0, 0(30); add 30,0,30")
#define LYNX_PIC_RESTORE asm ("lwz 30,8(1); addi 1,1,16");
#else
#define LYNX_CHECK_TOC
#define LYNX_PIC_RESTORE
#endif

# define CRT_CALL_STATIC_FUNCTION(SECTION_OP, FUNC)     \
static void __attribute__((__used__))                   \
call_ ## FUNC (void)                                    \
{                                                       \
  asm (SECTION_OP);                                     \
  LYNX_CHECK_TOC;                                      \
  FUNC ();                                              \
  LYNX_PIC_RESTORE;					\
  FORCE_CODE_SECTION_ALIGN                              \
  asm (TEXT_SECTION_ASM_OP);                            \
}

#define LYNX_TARGET

/* "long" is 32 bits. */
#undef LONG_TYPE_SIZE
#define LONG_TYPE_SIZE 32

#undef TARGET_64BIT
#define TARGET_64BIT    0

#undef TARGET_LITTLE_ENDIAN
#define TARGET_LITTLE_ENDIAN    0

#ifndef LIB_OS_LYNX_SPEC
# define LIB_OS_LYNX_SPEC "-lc -lm -lc"
#endif

/* Don't produce .eh_frame_hdr section for LynxOS */
#undef LINK_EH_SPEC
#define LINK_EH_SPEC ""

# define LINK_OS_LYNX_SPEC \
"%{L*} \
 %{mthreads: -L %:getenv(ENV_PREFIX /lib/thread)} \
 %{!mthreads: -L %:getenv(ENV_PREFIX /lib)} \
 %{-relax:--relax} %{-no-relax:--no-relax} %{!-relax:%{!-no-relax:--relax}}"

/* Dwarf2 debugging.  */
#undef  PREFERRED_DEBUGGING_TYPE
#define PREFERRED_DEBUGGING_TYPE DWARF2_DEBUG

/* Static stack checking is supported by means of probes.  */
#define STACK_CHECK_STATIC_BUILTIN 1
